package bdd;

import static bdd.CreateBdDepannTout.TABLE_INTER;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

import metier.Client;
import metier.Intervention;

public class InterventionDAO {
    private DAO dao = null;
    private SQLiteDatabase db = null;

    /**
     * Constructeur
     * @param context
     */

    public InterventionDAO(Context context){
        dao = new DAO(context);
        db = dao.open();
    }

    /**
     * Fermeture de la base de données
     */

    public void close() {
        dao.close();
    }

    public Cursor readLesInterventions() {
        String reqSql = "Select id as '_id', dateTime, observation, cliId FROM " + TABLE_INTER +";";
        // Execution de la requête
        Cursor c = db.rawQuery(reqSql, null);
        Log.d("bdd", "le curseur contient " + c.getCount() + " lignes");
        return c;
    }

    public long create(Intervention i) {
        Cursor cursor = db.rawQuery("SELECT id FROM client WHERE id = ?", new String[]{String.valueOf(i.getIdCli())});

        if (cursor != null && cursor.getCount() == 0) {
            cursor.close();
            Log.e("bdd", "Erreur : client avec id " + i.getIdCli() + " introuvable.");
            throw new IllegalArgumentException("Le client avec l’ID " + i.getIdCli() + " n’existe pas dans la base de données.");
        }

        if (cursor != null) {
            cursor.close();
        }

        ContentValues values = new ContentValues();
        values.put("datetime", i.getDateTime());
        values.put("cliId", i.getIdCli());
        values.put("observation", i.getObservation());

        Log.d("bdd", "insert : " + i);
        return db.insert(TABLE_INTER, null, values);
    }

    public boolean supprimerIntervention(int id) {
        int result = db.delete(TABLE_INTER,
                "id = ?",
                new String[]{String.valueOf(id)});
        db.close();
        return result > 0;
    }
    public Cursor getInterventionById(int id){
        return db.query("interventions", null, "_id = ?", new String[]{String.valueOf(id)}, null, null, null);
    }


        public boolean modifierIntervention(int id, int clientId, String dateHeure, String observation) {
            ContentValues values = new ContentValues();
            values.put("cliId", clientId);
            if(dateHeure !=null){
                values.put("datetime", dateHeure);
            }
            values.put("observation", observation);
            Log.d("modifierIntervention", "Modification de l'intervention avec ID: " + id);
            Log.d("modifierIntervention", "Valeurs à mettre à jour: " + values.toString());

            int result = db.update(TABLE_INTER, values, "id = ?", new String[]{String.valueOf(id)});

            Log.d("modifierIntervention", "Nombre de lignes affectées: " + result);

            db.close();
            return result > 0;
        }

}
